local BLIZZ_TRADEFRAMEEVENT = TradeFrame:GetScript("OnEvent");

function TradeFrameEventOverride(self, event, ...)
	local arg1, arg2 = ...;
	if ( event == "TRADE_SHOW" or event == "TRADE_UPDATE" ) then
		if TradeSkillFrame then TradeSkillFrameCollapse(); end;
		ShowUIPanel(self, 1);
		if ( not self:IsShown() ) then
			CloseTrade();
			return;
		end;
		TradeFrameTradeButton:Enable();
		TradeFrame_Update();
	elseif ( event == "TRADE_CLOSED" ) then
		if TradeSkillFrame then TradeSkillFrameExtend(); end;
		HideUIPanel(self);
	elseif ( event == "TRADE_TARGET_ITEM_CHANGED" ) then
		TradeFrame_UpdateTargetItem(arg1);
	elseif ( event == "TRADE_PLAYER_ITEM_CHANGED" ) then
		TradeFrame_UpdatePlayerItem(arg1);
	elseif ( event == "TRADE_ACCEPT_UPDATE" ) then
		TradeFrame_SetAcceptState(arg1, arg2);
	end;
end;

if GetUIPanelWidth(UIParent) < 1100 then TradeFrame:SetScript("OnEvent",TradeFrameEventOverride); end;

function TradeSkillFrameCollapse()
	TradeSkillFrame:SetAttribute("UIPanelLayout-area", "left");
	TradeSkillFrame:SetAttribute("UIPanelLayout-width", 384);
	TradeSkillFrame:SetWidth(384);
	TradeSkillFrame:SetHeight(512);
	TradeSkillRankFrame:SetWidth(265);
	TradeSkillListScrollFrame:ClearAllPoints();
	TradeSkillListScrollFrame:SetPoint("TOPRIGHT", TradeSkillFrame, "TOPRIGHT", -67, -96);
	TradeSkillListScrollFrame:SetHeight(130);
	TRADE_SKILLS_DISPLAYED = 8;
	for i = 8 + 1, 20 do
	   local button = getglobal("TradeSkillSkill"..i);
	   button:Hide();
	end;
	TradeSkillDetailScrollFrame:ClearAllPoints();
	TradeSkillDetailScrollFrame:SetPoint("TOPLEFT", TradeSkillFrame, "TOPLEFT", 20, -234);
	TradeSkillDetailScrollFrame:SetHeight(176);
	TradeSkillCreateButton:ClearAllPoints();
	TradeSkillCreateButton:SetPoint("CENTER", TradeSkillFrame, "TOPLEFT", 224, -422);
	TradeSkillCreateAllButton:ClearAllPoints();
	TradeSkillCreateAllButton:SetPoint("RIGHT", TradeSkillCreateButton, "LEFT", -86, 0);
	TradeSkillDecrementButton:ClearAllPoints();
	TradeSkillDecrementButton:SetPoint("LEFT", TradeSkillCreateAllButton, "RIGHT", 3, 0);
	TradeSkillInputBox:ClearAllPoints();
	TradeSkillInputBox:SetPoint("LEFT", TradeSkillDecrementButton, "RIGHT", 4, 0);
	TradeSkillIncrementButton:ClearAllPoints();
	TradeSkillIncrementButton:SetPoint("RIGHT", TradeSkillCreateButton, "LEFT", -3, 0);
	TradeSkillCancelButton:ClearAllPoints();
	TradeSkillCancelButton:SetPoint("CENTER", TradeSkillFrame, "TOPLEFT", 305, -422);
	TradeSkillHorizontalBarLeft:ClearAllPoints();
	TradeSkillHorizontalBarLeft:SetPoint("TOPLEFT",TradeSkillFrame, "TOPLEFT",15,-221);
	TradeSkillHorizontalBarLeft:SetWidth(256);
	TradeSkillHorizontalBarLeft:SetHeight(16);
	TradeSkillHorizontalBarLeft:SetTexture([[Interface\ClassTrainerFrame\UI-ClassTrainer-HorizontalBar]]);
	TradeSkillHorizontalBarLeft:SetTexCoord(0,1,0,0.25);
	TradeSkillHorizontalBarRight:ClearAllPoints();
	TradeSkillHorizontalBarRight:SetPoint("LEFT", TradeSkillHorizontalBarLeft,"RIGHT",0,0);
	TradeSkillHorizontalBarRight:SetWidth(75);
	TradeSkillHorizontalBarRight:SetHeight(16);
	TradeSkillHorizontalBarRight:SetTexture([[Interface\ClassTrainerFrame\UI-ClassTrainer-HorizontalBar]]);
	TradeSkillHorizontalBarRight:SetTexCoord(0,.29296875,0.25,0.5);
	TradeSkillFrameTopLeftTexture:SetWidth(256);
	TradeSkillFrameTopLeftTexture:SetHeight(256);
	TradeSkillFrameTopLeftTexture:SetTexture([[Interface\ClassTrainerFrame\UI-ClassTrainer-TopLeft]]);
	TradeSkillFrameBottomLeftTexture:SetWidth(256);
	TradeSkillFrameBottomLeftTexture:SetHeight(256);
	TradeSkillFrameTopRightTexture:ClearAllPoints();
	TradeSkillFrameTopRightTexture:SetPoint("TOPLEFT",TradeSkillFrameTopLeftTexture,"TOPRIGHT",0,0);
	TradeSkillFrameTopRightTexture:SetWidth(128);
	TradeSkillFrameTopRightTexture:SetHeight(256);
	TradeSkillFrameTopRightTexture:SetTexture([[Interface\ClassTrainerFrame\UI-ClassTrainer-TopRight]]);
	TradeSkillFrameBottomRightTexture:ClearAllPoints();
	TradeSkillFrameBottomRightTexture:SetPoint("BOTTOMLEFT",TradeSkillFrameBottomLeftTexture,"BOTTOMRIGHT",0,0);
	TradeSkillFrameBottomRightTexture:SetWidth(128);
	TradeSkillFrameBottomRightTexture:SetHeight(256);
	local _,_,_,_,altVerb = GetTradeSkillInfo(GetTradeSkillSelectionIndex());
	if ( IsTradeSkillLinked() ) then
		TradeSkillCreateButton:Hide();
		TradeSkillCreateAllButton:Hide();
		TradeSkillDecrementButton:Hide();
		TradeSkillInputBox:Hide();
		TradeSkillIncrementButton:Hide();
		TradeSkillLinkButton:Hide();
		TradeSkillFrameBottomLeftTexture:SetTexture([[Interface\PaperDollInfoFrame\SkillFrame-BotLeft]]);
		TradeSkillFrameBottomRightTexture:SetTexture([[Interface\PaperDollInfoFrame\SkillFrame-BotRight]]);
	else
		if ( not altVerb ) then
			TradeSkillCreateAllButton:Show();
			TradeSkillDecrementButton:Show();
			TradeSkillInputBox:Show();
			TradeSkillIncrementButton:Show();
			TradeSkillFrameBottomLeftTexture:SetTexture([[Interface\TradeSkillFrame\UI-TradeSkill-BotLeft]]);
			TradeSkillFrameBottomRightTexture:SetTexture([[Interface\ClassTrainerFrame\UI-ClassTrainer-BotRight]]);
		else
			TradeSkillCreateAllButton:Hide();
			TradeSkillDecrementButton:Hide();
			TradeSkillInputBox:Hide();
			TradeSkillIncrementButton:Hide();
			TradeSkillFrameBottomLeftTexture:SetTexture([[Interface\ClassTrainerFrame\UI-ClassTrainer-BotLeft]]);
			TradeSkillFrameBottomRightTexture:SetTexture([[Interface\ClassTrainerFrame\UI-ClassTrainer-BotRight]]);
		end;
		if ( GetTradeSkillListLink() ) then TradeSkillLinkButton:Show(); else TradeSkillLinkButton:Hide(); end;
		TradeSkillCreateButton:SetText(altVerb or CREATE);
		TradeSkillCreateButton:Show();
    end;
	TradeSkillRankFrameBorder:SetTexture([[Interface\PaperDollInfoFrame\UI-Character-Skills-BarBorder]]);
	TradeSkillRankFrameBorderB:ClearAllPoints();
	TradeSkillRankFrameBorderB:SetPoint("TOPLEFT", TradeSkillFrame, "TOPLEFT",0,0);
	TradeSkillRankFrameBorderC:ClearAllPoints();
	TradeSkillRankFrameBorderC:SetPoint("TOPLEFT", TradeSkillFrame, "TOPLEFT",0,0);
	TradeSkillRankFrameBorderB:Hide();
	TradeSkillRankFrameBorderC:Hide();
	TradeSkillListScrollFrameTopBar:SetWidth(30);
	TradeSkillListScrollFrameTopBar:SetHeight(120);
	TradeSkillListScrollFrameTopBar:ClearAllPoints();
	TradeSkillListScrollFrameTopBar:SetPoint("TOPLEFT", TradeSkillListScrollFrame, "TOPRIGHT", -3, 2 );
	TradeSkillListScrollFrameTopBar:SetTexture([[Interface\PaperDollInfoFrame\UI-Character-ScrollBar]]);
	TradeSkillListScrollFrameTopBar:SetTexCoord(0, .38, 0.01, .45);
	TradeSkillListScrollFrameBottomBar:SetWidth(30);
	TradeSkillListScrollFrameBottomBar:SetHeight(123);
	TradeSkillListScrollFrameBottomBar:ClearAllPoints();
	TradeSkillListScrollFrameBottomBar:SetPoint("BOTTOMLEFT", TradeSkillListScrollFrame, "BOTTOMRIGHT", -3, -2 );
	TradeSkillListScrollFrameBottomBar:SetTexture([[Interface\PaperDollInfoFrame\UI-Character-ScrollBar]]);
	TradeSkillListScrollFrameBottomBar:SetTexCoord(0.50, .96, .02, 0.4);
	TradeSkillDetailScrollFrameTopBar:SetWidth(30);
	TradeSkillDetailScrollFrameTopBar:SetHeight(123);
	TradeSkillDetailScrollFrameTopBar:ClearAllPoints();
	TradeSkillDetailScrollFrameTopBar:SetPoint("TOPLEFT", TradeSkillDetailScrollFrame, "TOPRIGHT", -2, -5 );
	TradeSkillDetailScrollFrameTopBar:SetTexture([[Interface\PaperDollInfoFrame\UI-Character-ScrollBar]]);
	TradeSkillDetailScrollFrameTopBar:SetTexCoord(0.01, .4, .04, .45);
	TradeSkillDetailScrollFrameBottomBar:SetWidth(30);
	TradeSkillDetailScrollFrameBottomBar:SetHeight(123);
	TradeSkillDetailScrollFrameBottomBar:ClearAllPoints();
	TradeSkillDetailScrollFrameBottomBar:SetPoint("BOTTOMLEFT", TradeSkillDetailScrollFrame, "BOTTOMRIGHT", -2, -1 );
	TradeSkillDetailScrollFrameBottomBar:SetTexture([[Interface\PaperDollInfoFrame\UI-Character-ScrollBar]]);
	TradeSkillDetailScrollFrameBottomBar:SetTexCoord(0.52, .98, 0, 0.40);
	TradeSkillFrame_SetSelection = BLIZZ_SetSelection;
	if TradeSkillFrame:IsShown() then HideUIPanel(TradeSkillFrame); end;
end;

function TradeSkillFrameExtend()
	TradeSkillFrame:SetAttribute("UIPanelLayout-area", "doublewide");
	TradeSkillFrame:SetAttribute("UIPanelLayout-width", 724);
	TradeSkillFrame:SetWidth(724);
	TradeSkillFrame:SetHeight(512);
	TradeSkillRankFrame:SetWidth(606);
	TradeSkillListScrollFrame:ClearAllPoints();
	TradeSkillListScrollFrame:SetPoint("LEFT", TradeSkillFrame, "LEFT", 18, 5);
	TradeSkillListScrollFrame:SetHeight(310);
	TRADE_SKILLS_DISPLAYED = 20;
	for i = 8 + 1, 20 do
		local button = getglobal("TradeSkillSkill"..i);
		button:Show();
	end;
	TradeSkillDetailScrollFrame:ClearAllPoints();
	TradeSkillDetailScrollFrame:SetPoint("LEFT", TradeSkillListScrollFrame, "RIGHT", 50, -10);
	TradeSkillDetailScrollFrame:SetHeight(310);
	TradeSkillCancelButton:ClearAllPoints();
	TradeSkillCancelButton:SetPoint("BOTTOMRIGHT", TradeSkillFrame, "BOTTOMRIGHT", -40, 80);
	TradeSkillHorizontalBarLeft:SetWidth(16);
	TradeSkillHorizontalBarLeft:SetHeight(256);
	TradeSkillHorizontalBarLeft:SetTexture("Interface\\AddOns\\TradeSkillHD\\UI-TradeSkill-VerticalBar");
	TradeSkillHorizontalBarLeft:SetTexCoord(0,.25,0,1);
	TradeSkillHorizontalBarRight:ClearAllPoints();
	TradeSkillHorizontalBarRight:SetPoint("TOP", TradeSkillHorizontalBarLeft, "BOTTOM",0,0);
	TradeSkillHorizontalBarRight:SetWidth(16);
	TradeSkillHorizontalBarRight:SetHeight(256);
	TradeSkillHorizontalBarRight:SetTexture("Interface\\AddOns\\TradeSkillHD\\UI-TradeSkill-VerticalBar");
	TradeSkillHorizontalBarRight:SetTexCoord(.25,.50,0,1);
	TradeSkillFrameTopLeftTexture:SetWidth(512);
	TradeSkillFrameTopLeftTexture:SetHeight(256);
	TradeSkillFrameTopLeftTexture:SetTexture("Interface\\AddOns\\TradeSkillHD\\UI-TradeSkill-TopLeft");
	TradeSkillFrameBottomLeftTexture:SetWidth(512);
	TradeSkillFrameBottomLeftTexture:SetHeight(256);
	TradeSkillFrameTopRightTexture:SetWidth(256);
	TradeSkillFrameTopRightTexture:SetHeight(256);
	TradeSkillFrameTopRightTexture:SetTexture("Interface\\AddOns\\TradeSkillHD\\UI-TradeSkill-TopRight");
	TradeSkillFrameTopRightTexture:ClearAllPoints();
	TradeSkillFrameTopRightTexture:SetPoint("TOPLEFT",TradeSkillFrameTopLeftTexture,"TOPRIGHT",0,0);
	TradeSkillFrameBottomRightTexture:ClearAllPoints();
	TradeSkillFrameBottomRightTexture:SetPoint("BOTTOMLEFT",TradeSkillFrameBottomLeftTexture,"BOTTOMRIGHT",0,0);
	TradeSkillFrameBottomRightTexture:SetWidth(256);
	TradeSkillFrameBottomRightTexture:SetHeight(256);
	local _,_,_,_,altVerb = GetTradeSkillInfo(GetTradeSkillSelectionIndex());
	if ( IsTradeSkillLinked() ) then
		TradeSkillCreateButton:Hide();
		TradeSkillCreateAllButton:Hide();
		TradeSkillDecrementButton:Hide();
		TradeSkillInputBox:Hide();
		TradeSkillIncrementButton:Hide();
		TradeSkillLinkButton:Hide();
		TradeSkillFrameBottomLeftTexture:SetTexture("Interface\\AddOns\\TradeSkillHD\\UI-TradeSkill-Link-BottomLeft");
		TradeSkillFrameBottomRightTexture:SetTexture("Interface\\AddOns\\TradeSkillHD\\UI-TradeSkill-Link-BottomRight");
	else
		if ( not altVerb ) then
			TradeSkillCreateAllButton:Show();
			TradeSkillDecrementButton:Show();
			TradeSkillInputBox:Show();
			TradeSkillIncrementButton:Show();
			TradeSkillFrameBottomLeftTexture:SetTexture("Interface\\AddOns\\TradeSkillHD\\UI-TradeSkill-BottomLeft");
			TradeSkillFrameBottomRightTexture:SetTexture("Interface\\AddOns\\TradeSkillHD\\UI-TradeSkill-BottomRight");
		else
			TradeSkillCreateAllButton:Hide();
			TradeSkillDecrementButton:Hide();
			TradeSkillInputBox:Hide();
			TradeSkillIncrementButton:Hide();
			TradeSkillFrameBottomLeftTexture:SetTexture("Interface\\AddOns\\TradeSkillHD\\UI-TradeSkill-AltVerb-BottomLeft");
			TradeSkillFrameBottomRightTexture:SetTexture("Interface\\AddOns\\TradeSkillHD\\UI-TradeSkill-BottomRight");
		end;
		if ( GetTradeSkillListLink() ) then TradeSkillLinkButton:Show(); else TradeSkillLinkButton:Hide(); end;
		TradeSkillCreateButton:SetText(altVerb or CREATE);
		TradeSkillCreateButton:Show();
    end;
	TradeSkillHorizontalBarLeft:ClearAllPoints();
	TradeSkillHorizontalBarLeft:SetPoint("TOP",TradeSkillFrame,"TOP",-17,-90);
	TradeSkillRankFrameBorder:SetTexture("Interface\\AddOns\\TradeSkillHD\\UI-TradeSkill-BarFix1");
	TradeSkillRankFrameBorderB:ClearAllPoints();	
	TradeSkillRankFrameBorderB:SetPoint("LEFT", TradeSkillRankFrameBorder,"RIGHT",0,0);
	TradeSkillRankFrameBorderB:Show();
	TradeSkillRankFrameBorderC:ClearAllPoints();
	TradeSkillRankFrameBorderC:SetPoint("LEFT", TradeSkillRankFrameBorderB, "RIGHT", 0,0);
	TradeSkillRankFrameBorderC:Show();
	TradeSkillListScrollFrameTopBar:SetWidth(30);
	TradeSkillListScrollFrameTopBar:SetHeight(253);
	TradeSkillListScrollFrameTopBar:ClearAllPoints();
	TradeSkillListScrollFrameTopBar:SetPoint("TOPLEFT", TradeSkillListScrollFrame, "TOPRIGHT", -2, 2 );
	TradeSkillListScrollFrameTopBar:SetTexture([[Interface\PaperDollInfoFrame\UI-Character-ScrollBar]]);
	TradeSkillListScrollFrameTopBar:SetTexCoord(0, 0.46875, 0.01171875, 1.0);
	TradeSkillListScrollFrameBottomBar:SetWidth(30);
	TradeSkillListScrollFrameBottomBar:SetHeight(108);
	TradeSkillListScrollFrameBottomBar:ClearAllPoints();
	TradeSkillListScrollFrameBottomBar:SetPoint("BOTTOMLEFT", TradeSkillListScrollFrame, "BOTTOMRIGHT", -2, -4 );
	TradeSkillListScrollFrameBottomBar:SetTexture([[Interface\PaperDollInfoFrame\UI-Character-ScrollBar]]);
	TradeSkillListScrollFrameBottomBar:SetTexCoord(0.515625, 0.984375, 0, 0.421875);
	TradeSkillDetailScrollFrameTopBar:SetWidth(30);
	TradeSkillDetailScrollFrameTopBar:SetHeight(253);
	TradeSkillDetailScrollFrameTopBar:ClearAllPoints();
	TradeSkillDetailScrollFrameTopBar:SetPoint("TOPLEFT", TradeSkillDetailScrollFrame, "TOPRIGHT", -2, 2 );
	TradeSkillDetailScrollFrameTopBar:SetTexture([[Interface\PaperDollInfoFrame\UI-Character-ScrollBar]]);
	TradeSkillDetailScrollFrameTopBar:SetTexCoord(0, 0.46875, 0.01171875, 1.0);
	TradeSkillDetailScrollFrameBottomBar:SetWidth(30);
	TradeSkillDetailScrollFrameBottomBar:SetHeight(108);
	TradeSkillDetailScrollFrameBottomBar:ClearAllPoints();
	TradeSkillDetailScrollFrameBottomBar:SetPoint("BOTTOMLEFT", TradeSkillDetailScrollFrame, "BOTTOMRIGHT", -2, -4 );
	TradeSkillDetailScrollFrameBottomBar:SetTexture([[Interface\PaperDollInfoFrame\UI-Character-ScrollBar]]);
	TradeSkillDetailScrollFrameBottomBar:SetTexCoord(0.515625, 0.984375, 0, 0.421875);
	TradeSkillFrame_SetSelection = TradeSkillFrameSSOverride;
	TradeSkillFrame_Update();
	if TradeSkillFrame:IsShown() then HideUIPanel(TradeSkillFrame); end;
end;